VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MCIDevice"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'==================================================================
'
' Interface to MCI Devices
'
' 30 September 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
'==================================================================


'------------------------------------------------------------------
' Current Settings

Private CurDeviceID As String
Private CurhWnd As Long
Private CurWait As Boolean

Private Const ID_FILLIN As String = "<ID>"


'------------------------------------------------------------------
' Public Constants

Private Const MCIERR_BASE = 256

Public Enum MCIDeviceIDs
  MCI_DEVTYPE_ALL = -1   'MCI_ALL_DEVICE_ID
  MCI_DEVTYPE_ANIMATION = 519
  MCI_DEVTYPE_CD_AUDIO = 516
  MCI_DEVTYPE_DAT = 517
  MCI_DEVTYPE_DIGITAL_VIDEO = 520
  MCI_DEVTYPE_OTHER = 521
  MCI_DEVTYPE_OVERLAY = 515
  MCI_DEVTYPE_SCANNER = 518
  MCI_DEVTYPE_SEQUENCER = 523
  MCI_DEVTYPE_VCR = 513
  MCI_DEVTYPE_VIDEODISC = 514
  MCI_DEVTYPE_WAVEFORM_AUDIO = 522
  
  MCI_DEVTYPE_FIRST_USER = &H1000
  MCI_DEVTYPE_FIRST = MCI_DEVTYPE_VCR
  MCI_DEVTYPE_LAST = MCI_DEVTYPE_SEQUENCER
End Enum

Public Enum MCIErrorCodes
  MCIERR_BAD_CONSTANT = (MCIERR_BASE + 34)
  MCIERR_BAD_INTEGER = (MCIERR_BASE + 14)
  MCIERR_BAD_TIME_FORMAT = (MCIERR_BASE + 37)
  MCIERR_CANNOT_LOAD_DRIVER = (MCIERR_BASE + 10)
  MCIERR_CANNOT_USE_ALL = (MCIERR_BASE + 23)
  MCIERR_CREATEWINDOW = (MCIERR_BASE + 91)
  MCIERR_CUSTOM_DRIVER_BASE = (MCIERR_BASE + 256)
  MCIERR_DEVICE_LENGTH = (MCIERR_BASE + 54)
  MCIERR_DEVICE_LOCKED = (MCIERR_BASE + 32)
  MCIERR_DEVICE_NOT_INSTALLED = (MCIERR_BASE + 50)
  MCIERR_DEVICE_NOT_READY = (MCIERR_BASE + 20)
  MCIERR_DEVICE_OPEN = (MCIERR_BASE + 9)
  MCIERR_DEVICE_ORD_LENGTH = (MCIERR_BASE + 55)
  MCIERR_DEVICE_TYPE_REQUIRED = (MCIERR_BASE + 31)
  MCIERR_DRIVER = (MCIERR_BASE + 22)
  MCIERR_DRIVER_INTERNAL = (MCIERR_BASE + 16)
  MCIERR_DUPLICATE_ALIAS = (MCIERR_BASE + 33)
  MCIERR_DUPLICATE_FLAGS = (MCIERR_BASE + 39)
  MCIERR_EXTENSION_NOT_FOUND = (MCIERR_BASE + 25)
  MCIERR_EXTRA_CHARACTERS = (MCIERR_BASE + 49)
  MCIERR_FILE_NOT_FOUND = (MCIERR_BASE + 19)
  MCIERR_FILE_NOT_SAVED = (MCIERR_BASE + 30)
  MCIERR_FILE_READ = (MCIERR_BASE + 92)
  MCIERR_FILE_WRITE = (MCIERR_BASE + 93)
  MCIERR_FILENAME_REQUIRED = (MCIERR_BASE + 48)
  MCIERR_FLAGS_NOT_COMPATIBLE = (MCIERR_BASE + 28)
  MCIERR_GET_CD = (MCIERR_BASE + 51)
  MCIERR_HARDWARE = (MCIERR_BASE + 6)
  MCIERR_ILLEGAL_FOR_AUTO_OPEN = (MCIERR_BASE + 47)
  MCIERR_INTERNAL = (MCIERR_BASE + 21)
  MCIERR_INVALID_DEVICE_ID = (MCIERR_BASE + 1)
  MCIERR_INVALID_DEVICE_NAME = (MCIERR_BASE + 7)
  MCIERR_INVALID_FILE = (MCIERR_BASE + 40)
  MCIERR_MISSING_COMMAND_STRING = (MCIERR_BASE + 11)
  MCIERR_MISSING_DEVICE_NAME = (MCIERR_BASE + 36)
  MCIERR_MISSING_PARAMETER = (MCIERR_BASE + 17)
  MCIERR_MISSING_STRING_ARGUMENT = (MCIERR_BASE + 13)
  MCIERR_MULTIPLE = (MCIERR_BASE + 24)
  MCIERR_MUST_USE_SHAREABLE = (MCIERR_BASE + 35)
  MCIERR_NEW_REQUIRES_ALIAS = (MCIERR_BASE + 43)
  MCIERR_NO_CLOSING_QUOTE = (MCIERR_BASE + 38)
  MCIERR_NO_ELEMENT_ALLOWED = (MCIERR_BASE + 45)
  MCIERR_NO_INTEGER = (MCIERR_BASE + 56)
  MCIERR_NO_WINDOW = (MCIERR_BASE + 90)
  MCIERR_NONAPPLICABLE_FUNCTION = (MCIERR_BASE + 46)
  MCIERR_NOTIFY_ON_AUTO_OPEN = (MCIERR_BASE + 44)
  MCIERR_NULL_PARAMETER_BLOCK = (MCIERR_BASE + 41)
  MCIERR_OUT_OF_MEMORY = (MCIERR_BASE + 8)
  MCIERR_OUTOFRANGE = (MCIERR_BASE + 26)
  MCIERR_PARAM_OVERFLOW = (MCIERR_BASE + 12)
  MCIERR_PARSER_INTERNAL = (MCIERR_BASE + 15)
  MCIERR_SEQ_DIV_INCOMPATIBLE = (MCIERR_BASE + 80)
  MCIERR_SEQ_NOMIDIPRESENT = (MCIERR_BASE + 87)
  MCIERR_SEQ_PORT_INUSE = (MCIERR_BASE + 81)
  MCIERR_SEQ_PORT_MAPNODEVICE = (MCIERR_BASE + 83)
  MCIERR_SEQ_PORT_MISCERROR = (MCIERR_BASE + 84)
  MCIERR_SEQ_PORT_NONEXISTENT = (MCIERR_BASE + 82)
  MCIERR_SEQ_PORTUNSPECIFIED = (MCIERR_BASE + 86)
  MCIERR_SEQ_TIMER = (MCIERR_BASE + 85)
  MCIERR_SET_CD = (MCIERR_BASE + 52)
  MCIERR_SET_DRIVE = (MCIERR_BASE + 53)
  MCIERR_UNNAMED_RESOURCE = (MCIERR_BASE + 42)
  MCIERR_UNRECOGNIZED_COMMAND = (MCIERR_BASE + 5)
  MCIERR_UNRECOGNIZED_KEYWORD = (MCIERR_BASE + 3)
  MCIERR_UNSUPPORTED_FUNCTION = (MCIERR_BASE + 18)
  MCIERR_WAVE_INPUTSINUSE = (MCIERR_BASE + 66)
  MCIERR_WAVE_INPUTSUNSUITABLE = (MCIERR_BASE + 72)
  MCIERR_WAVE_INPUTUNSPECIFIED = (MCIERR_BASE + 69)
  MCIERR_WAVE_OUTPUTSINUSE = (MCIERR_BASE + 64)
  MCIERR_WAVE_OUTPUTSUNSUITABLE = (MCIERR_BASE + 70)
  MCIERR_WAVE_OUTPUTUNSPECIFIED = (MCIERR_BASE + 68)
  MCIERR_WAVE_SETINPUTINUSE = (MCIERR_BASE + 67)
  MCIERR_WAVE_SETINPUTUNSUITABLE = (MCIERR_BASE + 73)
  MCIERR_WAVE_SETOUTPUTINUSE = (MCIERR_BASE + 65)
  MCIERR_WAVE_SETOUTPUTUNSUITABLE = (MCIERR_BASE + 71)
End Enum


'------------------------------------------------------------------
' API's


Private Declare Function mciGetCreatorTask Lib "winmm.dll" (ByVal wDeviceID As Long) As Long
Private Declare Function mciGetDeviceID Lib "winmm.dll" Alias "mciGetDeviceIDA" (ByVal lpstrName As String) As Long
Private Declare Function mciGetErrorString Lib "winmm.dll" Alias "mciGetErrorStringA" (ByVal dwError As Long, ByVal lpstrBuffer As String, ByVal uLength As Long) As Long
Private Declare Function mciSendCommand Lib "winmm.dll" Alias "mciSendCommandA" (ByVal wDeviceID As Long, ByVal uMessage As Long, ByVal dwParam1 As Long, dwParam2 As Any) As Long
Private Declare Function mciSendString Lib "winmm.dll" Alias "mciSendStringA" (ByVal lpstrCommand As String, ByVal lpstrReturnString As String, ByVal uReturnLength As Long, ByVal hwndCallback As Long) As Long
Private Declare Function mciGetYieldProc Lib "winmm" (ByVal mciId As Long, pdwYieldData As Long) As Long
Private Declare Function mciSetYieldProc Lib "winmm" (ByVal mciId As Long, ByVal fpYieldProc As Long, ByVal dwYieldData As Long) As Long
Private Declare Function IsTextUnicode Lib "advapi32" (lpBuffer As Any, ByVal cb As Long, lpi As Long) As Long
Private Declare Function IsWindow Lib "user32" (ByVal hWnd As Long) As Long

' Misc Mci Commands for MciSendCmdString:
'capability ALIAS {can eject|can play|can record|can save|compound device|has audio|has video|uses files} => true|false
'capability ALIAS device type => {cdaudio|dat|digitalvideo|other|overlay|scanner|sequencer|vcr|videodisc|waveaudio}
'sysinfo ALIAS  installname
'sysinfo DEVICE {quantity|quantity open|name INDEX|name INDEX open}




'------------------------------------------------------------------
' Attach

Public Sub Attach(MCIDeviceID As String, Optional hWndNotify As Long)
  If CurDeviceID <> "" Then Error 5
  If hWndNotify <> 0 Then
    If IsWindow(hWndNotify) = 0 Then Err.Raise 380, , MCIDeviceID & " notification window does not exist"
  End If
  CurDeviceID = MCIDeviceID
  CurhWnd = hWndNotify
End Sub


'------------------------------------------------------------------
' Get Information

Public Property Get ID() As String
  ID = CurDeviceID
End Property

Public Property Get LongID() As Long
  LongID = mciGetDeviceID(CurDeviceID)
'  If MciDeviceLongID = 0 Then Err.Raise 12345, "MciPlayer.MciDeviceName", "Invalid DeviceID/Alias or out of memory!"
End Property

Public Property Get Creator() As Long
  Creator = mciGetCreatorTask(CurDeviceID)
  If Creator = 0 Then Err.Raise 12345, "MciPlayer.MciDeviceCreator", "Invalid DeviceID/Alias!"
End Property

'------------------------------------------------------------------
' Send Comands

Public Function SendCommand(ByVal Command As String) As String
  Dim ReturnString As String
  Dim MciError As MCIErrorCodes
  
  If CurhWnd Then
    If IsWindow(CurhWnd) = 0 Then Err.Raise 5, , "Bad window handle for notification"
  End If
  
  ReturnString = Space(128)
  Command = Replace(Command, ID_FILLIN, CurDeviceID, , , vbTextCompare)
  Command = Command & IIf(CurWait, " wait", "") & IIf(CurhWnd, " notify", "")
  MciError = mciSendString(Command, ReturnString, Len(ReturnString), CurhWnd)
  ReturnString = CStrFromStrZ(ReturnString)
  
  Debug.Print "MCI: (" & Command & ")" & IIf(ReturnString <> "", " = " & ReturnString, "") & IIf(MciError, " FAILED!", "")
  
  If MciError <> 0 Then Err.Raise 10000 + MciError, "MCIDevice.SendCommand", ErrorDescription(MciError)
  SendCommand = ReturnString
End Function

Public Sub SendLongCommand(Command As MCICommonCommands, CmdSpecificflags As Long, Optional ByVal CmdSpecificStructPtr As Long)
  Dim MciError As MCIErrorCodes
  MciError = mciSendCommand(CurDeviceID, Command, CmdSpecificflags, ByVal CmdSpecificStructPtr)
  If MciError <> 0 Then Err.Raise 10000 + MciError, "MCIDevice.SendLongCommand", ErrorDescription(MciError)
End Sub

Public Sub CloseAll()
  Call Me.SendCommand("close all")
End Sub


'------------------------------------------------------------------
' Error Description

Public Function ErrorDescription(MciError As MCIErrorCodes) As String
  Dim Buffer As String
  Buffer = Space(128)
  If mciGetErrorString(MciError, Buffer, Len(Buffer)) = 0 Then Err.Raise 10000, "MCIDevice.ErrorDescription", "Error not defined by MCI!"
  ErrorDescription = CStrFromStrZ(Buffer)
End Function


'------------------------------------------------------------------
' YieldProc

Public Property Get YieldProc(Optional ByRef lParam As Long) As Long
  YieldProc = mciGetYieldProc(CurDeviceID, lParam)
End Property

Public Property Let YieldProc(Optional ByRef lParam As Long, NewValue As Long)
  If mciSetYieldProc(CurDeviceID, lParam, NewValue) = 0 Then Error 5
End Property


'------------------------------------------------------------------
' hWndNotify

Public Property Get hWndNotify() As Long
  hWndNotify = CurhWnd
End Property

Public Property Let hWndNotify(NewValue As Long)
  If NewValue <> 0 Then
    If IsWindow(NewValue) = 0 Then Err.Raise 380, , "Invalid Window Handle"
  End If
  CurhWnd = NewValue
End Property


'------------------------------------------------------------------
' Wait

Public Property Get Wait() As Boolean
  Wait = CurWait
End Property

Public Property Let Wait(NewValue As Boolean)
  CurWait = NewValue
End Property


'------------------------------------------------------------------
' Util

Private Function CStrFromStrZ(ByVal szStr As String) As String
  Dim Flag As Long
  Dim Pos As Long
  
  ' Is Unicode?
  Flag = &HF ' const IS_TEXT_UNICODE_UNICODE_MASK = &HF
  If CBool(IsTextUnicode(ByVal szStr, Len(szStr), Flag)) Then szStr = StrConv(szStr, vbFromUnicode)
  Pos = InStr(szStr, vbNullChar)
  
  If Pos Then
    CStrFromStrZ = Left$(szStr, Pos - 1)
  Else
    CStrFromStrZ = szStr
  End If
End Function
